#include "simpletools.h"
#include "fdserial.h"

#define XBSER_BUFF_MASK 10;

typedef text_t xbee;
/**
 * Defines fdserial interface struct
 * 9 contiguous longs + buffers
 */
typedef struct xbee_struct
{
    int  rx_head;   /* receive queue head */
    int  rx_tail;   /* receive queue tail */
    int  tx_head;   /* transmit queue head */
    int  tx_tail;   /* transmit queue tail */
    int  rx_pin;    /* recieve pin */
    int  tx_pin;    /* transmit pin */
    int  mode;      /* interface mode */
    int  ticks;     /* clkfreq / baud */
    char *buffptr;  /* pointer to rx buffer */
    char *xbreply;
} xbee_st;

void xbee_cmdPrint(int onOff);
char *xbee_cmd(text_t *device, char *cmd);


/*
 * start initializes and starts native assembly driver in a cog.
 * @param rxpin is pin number for XBee DO pin 
 * @param txpin is pin number for XBee DI pin 
 */
text_t *xbee_open(int rxpin, int txpin);
xbee *xbee_start(int rxpin, int txpin, int baudrate);
void xbee_close(text_t *term);
void xbee_baudRate(xbee *device, int baud);
